' Einfaches Kartenaufdeckspiel
' PC-Umsetzung (c) 2007 by Andreas Meile, CH-8242 Hofen SH
' Originalspielidee: Otto Meier Varlag, D-88214 Ravensburg

CONST PalVGA% = 2

DECLARE SUB LadeBild (dn$, f%(), ind%)
DECLARE SUB LadePalette (dn$, p&(), ind%, mo%)
DECLARE SUB ZeigeKarte (x%, y%, offen%)
DECLARE SUB ZeigeZeit ()
DECLARE SUB ZeigeVersuche ()
DECLARE SUB ZeigePaare ()
DECLARE FUNCTION FuehrNull$ (w%, B%)
DECLARE SUB ZeichneCursor (x%, y%, f%)

DIM tmp%(13164), pal&(255)
DIM SHARED Bild%(797, 12), misch%(5, 3), anzVer%, anzPa%, zeit%

RANDOMIZE TIMER

SCREEN 13

' Bilder laden
LadeBild "motive", tmp%(), 0
LadePalette "motive", pal&(), 0, PalVGA%
PALETTE USING pal&
PUT (0, 0), tmp%, PSET

' und in Array abfllen
FOR i% = 0 TO 12
  GET (1 + 45 * (i% MOD 5), 1 + 39 * (i% \ 5))-STEP(42, 36), Bild%(0, i%)
NEXT i%

CLS
COLOR 206
LOCATE 1, 2
PRINT "Zeit:xx:xx Aufgedeckt:XX Versuche:XXX"
FOR y% = 0 TO 3
  FOR x% = 0 TO 5
    LINE (6 + 52 * x%, 14 + 46 * y%)-STEP(46, 40), 251, BF
    misch%(x%, y%) = x% + 6 * (y% MOD 2)
    ZeigeKarte x%, y%, 0
  NEXT x%
NEXT y%

' Mischen
FOR i% = 0 TO 23
  h% = CINT(INT(24! * RND))
  IF h% <> i% THEN
    SWAP misch%(i% MOD 6, i% \ 6), misch%(h% MOD 6, h% \ 6)
  END IF
NEXT i%

zeit% = 0
anzVer% = 0
anzPa% = 0
ZeigeZeit
ZeigeVersuche
ZeigePaare

x% = 0
y% = 0
drinb% = -1
tn! = TIMER + 1!
px% = -1
py% = -1
WHILE drinb%
  ZeichneCursor x%, y%, 206
  DO
    t$ = INKEY$
    IF TIMER >= tn! THEN
      zeit% = zeit% + 1
      tn! = tn! + 1!
      ZeigeZeit
    END IF
  LOOP WHILE t$ = ""
  ZeichneCursor x%, y%, 0
  SELECT CASE t$
  CASE CHR$(0) + "H"
    y% = (y% + 3) MOD 4
  CASE CHR$(0) + "K"
    x% = (x% + 5) MOD 6
  CASE CHR$(0) + "M"
    x% = (x% + 1) MOD 6
  CASE CHR$(0) + "P"
    y% = (y% + 1) MOD 4
  CASE CHR$(13), " "
    IF misch%(x%, y%) <> -1 THEN
      IF px% = -1 THEN
        ' Aufdecken der 1. Karte
        ZeigeKarte x%, y%, -1
        SOUND 900, 2!
        px% = x%
        py% = y%
      ELSE
        IF x% = px% AND y% = py% THEN
          ' Fehler: bereits aufgedeckt
          SOUND 250, 5
        ELSE
          ' Aufdecken 2. Karte
          ZeigeKarte x%, y%, -1
          ' Auswerten
          SOUND 900, 2!
          IF misch%(x%, y%) = misch%(px%, py%) THEN
            ' Treffer: Paar gefunden :-)
            PLAY "t200l8o2g>cegl16ggggl8egec"
            anzPa% = anzPa% + 1
            ZeigePaare
            misch%(x%, y%) = -1
            misch%(px%, py%) = -1
            IF anzPa% = 12 THEN
              drinb% = 0
            END IF
          ELSE
            ' Leider verschieden :-(
            FOR i% = 770 TO 470 STEP -50
              SOUND i%, 1!
              SOUND i% - 200, 1!
            NEXT
            ZeigeKarte px%, py%, 0
            ZeigeKarte x%, y%, 0
            anzVer% = anzVer% + 1
            ZeigeVersuche
          END IF
          px% = -1
          py% = -1
        END IF
      END IF
    ELSE
      ' Fehler: bereits Lcke
      SOUND 250, 5
    END IF
  CASE CHR$(27)
    drinb% = 0
  END SELECT
WEND

IF anzPa% = 12 THEN
  LINE (96, 96)-STEP(127, 15), 206, BF
  LINE (100, 92)-STEP(127, 15), 0, BF
  LINE (100, 92)-STEP(127, 15), 251, B
  LINE (102, 94)-STEP(123, 11), 251, B
  LOCATE 13, 14
  PRINT "Spiel komplett!"
  PLAY "t200o3l8cp8cdededl4cl8cdl4gp8l8gedgedge>cc<b>c"
  d$ = INPUT$(1)
END IF

SCREEN 0
WIDTH 80, 25

FUNCTION FuehrNull$ (w%, B%)
  h$ = MID$(STR$(w%), 2)
  FuehrNull$ = STRING$(B% - LEN(h$), "0") + h$
END FUNCTION

SUB LadeBild (dn$, f%(), ind%)
  OPEN dn$ + ".BMP" FOR INPUT AS 1
  CLOSE 1
  OPEN dn$ + ".BMP" FOR BINARY AS 1
  k$ = INPUT$(2, 1)
  IF k$ <> "BM" THEN
    PRINT "Kein gltiges Windows Bitmap Bild!"
    ERROR 5
  END IF
  SEEK 1, 11&
  basOf& = CVL(INPUT$(4, 1)) + 1&  ' ab hier beginnen die Nutzdaten
  SEEK 1, 19&
  xb& = CVL(INPUT$(4, 1))  ' Bildgrsse
  yb& = CVL(INPUT$(4, 1))
  anzBpl% = CVI(INPUT$(2, 1))
  IF anzBpl% <> 1 THEN
    PRINT "Bildformat einer knftigen Windowsversion"
    ERROR 5
  END IF
  bpp% = CVI(INPUT$(2, 1))
  komp& = CVL(INPUT$(4, 1))
  IF komp& <> 0& THEN
    PRINT "Komprimierung nicht untersttzt"
    ERROR 5
  END IF
  ' Start der Verarbeitung
  br& = (xb& * CLNG(bpp%) + 31& AND -32&) \ 8&
  IF bpp% = 8 THEN
    f%(ind%) = 8 * CINT(xb&)
  ELSE
    f%(ind%) = CINT(xb&)
  END IF
  f%(ind% + 1) = CINT(yb&)
  ind% = ind% + 2
  SELECT CASE bpp%
  CASE 1, 8
    IF bpp% = 1 THEN
      B% = CINT((xb& + 7&) \ 8&)
    ELSE
      B% = CINT(xb&)
    END IF
    Pu$ = ""
    FOR y& = basOf& + br& * (yb& - 1&) TO basOf& STEP -br&
      SEEK 1, y&
      FOR x% = 1 TO B%
        Pu$ = Pu$ + INPUT$(1, 1)
        IF LEN(Pu$) = 2 THEN
          f%(ind%) = CVI(Pu$)
          ind% = ind% + 1
          Pu$ = ""
        END IF
      NEXT x%
    NEXT y&
    IF Pu$ <> "" THEN
      f%(ind%) = CVI(Pu$ + " ")
      ind% = ind% + 1
    END IF
  CASE 4
    DIM h%(3)
    FOR i% = 0 TO 3
      h%(i%) = 0
    NEXT i%
    B% = CINT(br&) \ 4
    pu1$ = SPACE$(4 * B%)
    FOR y& = basOf& + br& * (yb& - 1&) TO basOf& STEP -br&
      SEEK 1, y&
      FOR x1% = 1 TO B%
        FOR x2% = 1 TO 4
          z% = ASC(INPUT$(1, 1))
          FOR x3% = 0 TO 3
            h%(x3%) = 4 * h%(x3%) + (z% AND 1) + (z% AND 16) \ 8
            z% = z% \ 2
          NEXT x3%
        NEXT x2%
        FOR i% = 0 TO 3
          MID$(pu1$, x1% + B% * i%) = CHR$(h%(i%))
          h%(i%) = 0
        NEXT i%
      NEXT x1%
      FOR i% = 1 TO LEN(pu1$) STEP 2
        f%(ind%) = CVI(MID$(pu1$, i%, 2))
        ind% = ind% + 1
      NEXT i%
    NEXT y&
  CASE 24
    PRINT "Echtfarb (True Color) nicht mglich"
    ERROR 5
  CASE ELSE
    PRINT "Unbekannte Bildtiefe"
    ERROR 5
  END SELECT
  CLOSE 1
END SUB

SUB LadePalette (dn$, p&(), ind%, mo%)
  OPEN dn$ + ".BMP" FOR INPUT AS 1
  CLOSE 1
  OPEN dn$ + ".BMP" FOR BINARY AS 1
  k$ = INPUT$(2, 1)
  IF k$ <> "BM" THEN
    PRINT "Kein gltiges Windows Bitmap Bild!"
    ERROR 5
  END IF
  SEEK 1, 15&
  palOf& = CVL(INPUT$(4, 1)) + 15&   ' ab hier beginnen die Farbeintrge
  SEEK 1, 27&
  anzBpl% = CVI(INPUT$(2, 1))
  IF anzBpl% <> 1 THEN
    PRINT "Bildformat einer knftigen Windowsversion"
    ERROR 5
  END IF
  bpp% = CVI(INPUT$(2, 1))
  IF bpp% > 12 THEN
    PRINT "Echtfarb verwendet keine Farbpalette"
    ERROR 5
  END IF
  ' Start der Verarbeitung
  aF% = 1
  FOR i% = 1 TO bpp%
    aF% = aF% * 2
  NEXT i%
  IF mo% = PalVlf% THEN
    ' verlustfreier Spezialmodus, der keinem SCREEN gehrt
    ' liest gesamter RGBQUAD ein
    SEEK 1, palOf&
    FOR i% = 1 TO aF&
      p&(ind%) = CVL(INPUT$(4, 1))
      ind% = ind% + 1
    NEXT i%
  ELSE
    FOR i% = 1 TO aF%
      SEEK 1, palOf&
      B% = ASC(INPUT$(1, 1))
      g% = ASC(INPUT$(1, 1))
      r% = ASC(INPUT$(1, 1))
      SELECT CASE mo%
      CASE PalCGA%  ' CGA-Palette von SCREEN 1/2/7/8
        Cga% = (r% AND 128) \ 32 + (g% AND 128) \ 64 + (B% AND 128) \ 128
        ' Selektion, ob hellerer oder dnklerer Farbton darstellen
        h% = (r% AND 127) + (g% AND 127) + (B% AND 127) - 192
        p&(ind%) = CLNG(Cga% - 8 * (h% > 0))
        IF p&(ind%) = 4 AND g% > 80 THEN
          p&(ind%) = 6   ' Spezialfall Orange
        END IF
      CASE PalEGA%  ' EGA-Palette von SCREEN 0/9
        p&(ind%) = CLNG((r% AND 64) \ 2 + (r% AND 128) \ 32 + (g% AND 64) \ 4 + (g% AND 128) \ 64 + (B% AND 64) \ 8 + (B% AND 128) \ 128)
      CASE PalVGA%  ' VGA-Palette von SCREEN 11/12/13
        p&(ind%) = CLNG(r% AND 252) \ 4& + CLNG(g% AND 252) * 64& + CLNG(B% AND 252) * 16384&
      CASE ELSE
        ERROR 5
      END SELECT
      palOf& = palOf& + 4&
      ind% = ind% + 1
    NEXT i%
  END IF
  CLOSE 1
END SUB

SUB ZeichneCursor (x%, y%, f%)
  LINE (2 + 52 * x%, 10 + 46 * y%)-STEP(54, 2), f%, BF
  LINE (2 + 52 * x%, 13 + 46 * y%)-STEP(2, 42), f%, BF
  LINE (54 + 52 * x%, 13 + 46 * y%)-STEP(2, 42), f%, BF
  LINE (2 + 52 * x%, 56 + 46 * y%)-STEP(54, 2), f%, BF
END SUB

SUB ZeigeKarte (x%, y%, offen%)
  IF offen% THEN
    h% = misch%(x%, y%)
  ELSE
    h% = 12
  END IF
  PUT (8 + 52 * x%, 16 + 46 * y%), Bild%(0, h%), PSET
END SUB

SUB ZeigePaare
  LOCATE 1, 24
  COLOR 251
  PRINT FuehrNull$(anzPa%, 2);
END SUB

SUB ZeigeVersuche
  LOCATE 1, 36
  COLOR 251
  PRINT FuehrNull$(anzVer%, 3)
END SUB

SUB ZeigeZeit
  LOCATE 1, 7
  COLOR 251
  PRINT FuehrNull$(zeit% \ 60, 2) + ":" + FuehrNull$(zeit% MOD 60, 2);
END SUB

